diff -r bebe54e1d640 src/lib-storage/index/imapc/imapc-storage.c
--- a/src/lib-storage/index/imapc/imapc-storage.c	Tue Nov 27 02:41:53 2012 +0200
+++ b/src/lib-storage/index/imapc/imapc-storage.c	Tue Nov 27 02:58:09 2012 +0200
@@ -222,6 +222,11 @@
 	}
 	set.port = storage->set->imapc_port;
 	set.username = storage->set->imapc_user;
+	if (*set.username == '\0' && ns->type == NAMESPACE_SHARED) {
+		/* accessing another user's shared mailbox. set the username
+		   automatically. */
+		set.username = ns->owner->username;
+	}
 	set.master_user = storage->set->imapc_master_user;
 	set.password = storage->set->imapc_password;
 	if (*set.password == '\0') {
diff -r bebe54e1d640 src/lib-storage/index/shared/shared-storage.c
--- a/src/lib-storage/index/shared/shared-storage.c	Tue Nov 27 02:41:53 2012 +0200
+++ b/src/lib-storage/index/shared/shared-storage.c	Tue Nov 27 02:58:09 2012 +0200
@@ -299,6 +299,8 @@
 				"nonexistent user %s", userdomain);
 		}
 	}
+	if (strncmp(str_c(location), "imapc:", 6) == 0)
+		new_ns->flags |= NAMESPACE_FLAG_NOACL;
 
 	ns_set = p_new(user->pool, struct mail_namespace_settings, 1);
 	ns_set->type = "shared";
